## Indexing Genomics Big Data

Next-Generation Sequencing (NGS), also known as high-throughput sequencing, has opened the possibility of a comprehensive characterization of the genomic and epigenomic landscapes, giving answers to fundamental questions for biological and clinical research. In this context, our research has focused on discovering how heterogeneous DNA regions concur to determine particular biological processes or phenotypes.

Di4, 1D intervals incremental inverted index, is a multi-resolution single-dimension data structure for interval-based data queries. It implements characteristic operations to be performed on region data regard identifying co-occurrences of regions, from different biological tests and/or of distinct semantic types, possibly within a certain distance from each others and/or from DNA regions with known structural or functional properties.


## Documentation
Read [documentation](https://genometric.github.io/Di4/docs.html) on:
- [how to install Di4](https://genometric.github.io/Di4/installation.html);
- [how to index data using Di4](https://genometric.github.io/Di4/indexing.html);
- [how to perform high-level queries/operations on the indexed data](https://genometric.github.io/Di4/logical.html).


## Publication
- Jalili, V., Matteucci, M., Goecks, J., Deldjoo, Y., & Ceri, S. (2018). [Next generation indexing for genomic intervals.](https://ieeexplore.ieee.org/abstract/document/8468044) IEEE Transactions on Knowledge and Data Engineering.
- Jalili, V., Matteucci, M., Masseroli, M., & Ceri, S. (2017). [Indexing next-generation sequencing data.](https://www.sciencedirect.com/science/article/pii/S0020025516306685) Information Sciences, 384, 90-109.
